//Titel:        JTree
//Version:       1.0
//Copyright:     Copyright (c) 2003 ,06
//Autor:         Dipl.-Inf., Dipl.-Ing. (FH) Michael Wilhelm
//Organisation:  HS Harz
//Beschreibung:  Einführung in JTree


// Einfaches Beispiel mit DefaultMutableTreeNode
// CTreeNodeRec liefert Zusatzinformationen, mit toString
// Klick Ereignis, Single bzw. Double-Click
// Die KlickID ist je nach Baumstruktur unterschiedlich
// Einfach Aeste oeffnen  


import java.awt.*;
import javax.swing.*;

import java.awt.event.*;

import javax.swing.tree.DefaultMutableTreeNode;

import javax.swing.tree.*;

import javax.swing.event.*;

import java.io.*;

import java.util.Vector;



public class Tree07 extends JFrame {

  JTree jTree1;
  DefaultMutableTreeNode rootNode;
  DefaultTreeModel treeModel;
  TreePath RootPath;

  int _index;

  public Tree07() {
    setGUI();
  }

  private void setGUI() {
    setSize(400, 300);
    setTitle("JTree 7. Beispiel");
    this.getContentPane().setLayout( new BorderLayout() );


    //---------------------------------------
    rootNode = BuildTree();

    treeModel = new DefaultTreeModel(rootNode);
    jTree1 = new javax.swing.JTree(treeModel);  //  kein Root !!!
   jTree1.setFont( new Font("Arial", Font.BOLD,22)  );


    jTree1.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
    // jTree1.getSelectionModel().setSelectionMode(TreeSelectionModel.DISCONTIGUOUS_TREE_SELECTION);
   //  SINGLE_TREE_SELECTION, CONTIGUOUS_TREE_SELECTION or DISCONTIGUOUS_TREE_SELECTION.


     MouseListener ml = new CMouseAdapter(jTree1);
     jTree1.addMouseListener(ml);


    jTree1.setBorder(BorderFactory.createLineBorder(Color.black));
    jTree1.setToolTipText("ToolTipp");
    jTree1.setShowsRootHandles(true);

      // Horizontale Linien
    jTree1.putClientProperty("JTree.lineStyle","Horizontal");
      // Mit Linien zwischen den Knoten
    jTree1.putClientProperty("JTree.lineStyle","Angled");

    this.getContentPane().add(jTree1, BorderLayout.CENTER);

    // Neue Version
    // setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

  }  // setGUI



  // ----------------------------
  DefaultMutableTreeNode BuildTree() {
    DefaultMutableTreeNode root;
    DefaultMutableTreeNode Kn0, Kn1, Kn2;

    root = createCNode(  0,"root");  // new DefaultMutableTreeNode("root");

      // liefert einen DefaultMutableTreeNode
    Kn0 = createCNode(  1,"1. Stufe (1)");
    root.add( Kn0 );

    Kn1 = createCNode(  2,"AAA");
    Kn0.add( Kn1 );  // Parameter Vater
    Kn1 = createCNode(  3,"BBB");
    Kn0.add( Kn1 );  // Parameter Vater


    // ---------

    Kn0 = createCNode(  2,"1. Stufe (2)");
    root.add( Kn0 );

    Kn1 = createCNode(  6,"CCC");
    Kn0.add( Kn1 );  // Parameter Vater
    Kn1 = createCNode(  2,"DDDD");
    Kn0.add( Kn1 );  // Parameter Vater


    Kn0 = createCNode(  3,"1. Stufe (3)");
    root.add( Kn0 );

    Kn1 = createCNode(  6,"EEE");
    Kn0.add( Kn1 );  // Parameter Vater

      Kn2 = createCNode(  7,"E1E1E1");
      Kn1.add( Kn2 );  // Parameter Vater
      Kn2 = createCNode(  2,"E2E2E2");
      Kn1.add( Kn2 );  // Parameter Vater

    Kn1 = createCNode(  11,"FFF");
    Kn0.add( Kn1 );  // Parameter Vater
      Kn2 = createCNode(  2,"F1F1F1");
      Kn1.add( Kn2 );  // Parameter Vater
      Kn2 = createCNode(  4,"F2F2F2");
      Kn1.add( Kn2 );  // Parameter Vater

    return root;
  }  // BuildTree


 DefaultMutableTreeNode createCNode(int CData,  String nodeString) {
    CTreeNodeRec CNode;
    DefaultMutableTreeNode Node;

    CNode = new  CTreeNodeRec(CData, nodeString);
    Node = new DefaultMutableTreeNode(CNode);
    // Node = new DefaultMutableTreeNode(nodeString);
    //Node.setUserObject(CNode);
    return Node;
 }



  //Überschreiben, damit das Programm bei Herunterfahren des Systems beendet werden kann
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  public static void main(String[] args) {
    Tree07 frame = new Tree07();
    frame.setVisible(true);
 }


}




// Einfache Klasse für jeden Knoten
class CTreeNodeRec  {
  public static long nr=0;

    private long _id = 0; // Id des Knotens  z.B. als ID

    private int _CData;

    public String _nodeString;


   public CTreeNodeRec(int CData,  String nodeString) {
      _CData = CData;
      _nodeString = nodeString;  // für JTree;
      nr++;
      _id = nr;  // setzt eindeutige Nummer
   }


   public long getID() {
     return _id;
   }

   public int getData() {
     return _CData;
   }

   public void setData(int CData) {
     _CData = CData;
   }


   // sehr wichtig
   public String toString() {
     return _nodeString;
   }
   

}  // CTreeNodeRec




// Klassen implementiert den Maus-Listener
class CMouseAdapter extends MouseAdapter {
   private JTree jTree1;

  public CMouseAdapter(JTree jTree1) {
     this.jTree1 = jTree1;
  }

   public void mouseClicked(MouseEvent e) {
      int selRow = jTree1.getRowForLocation(e.getX(), e.getY());
      TreePath selPath = jTree1.getPathForLocation(e.getX(), e.getY());
      if(selRow != -1) {
         if(e.getClickCount() == 1) {
             SingleClick(selRow, selPath);
         }
         else if(e.getClickCount() == 2) {
             DoubleClick(selRow, selPath);
         }
     }
  }

  void  SingleClick(int selRow, TreePath selPath) {
    System.out.println("CSingleClick: "+selRow);
  }

  void  DoubleClick(int selRow, TreePath selPath) {
    System.out.println("CDoubleClick: "+selRow);
  }

}  // CMouseAdapter






